Subject: Re: [bug#30084] [PATCH] gnu: Add urho3d.

From: [email-masked] (Ludovic Courtès)
Date: Tue, 23 Jan 2018 15:07:52 +0100

Hello,

Oleg Pykhalov <[email-masked]> skribis:

> [email-masked] (Ludovic Courtès) writes:
>
>> Hi Oleg,
>>
>> Oleg Pykhalov <[email-masked]> skribis:
>>
>>> From 186090075a1ae515bb4893763e7c528568e15939 Mon Sep 17 00:00:00 2001
>>> From: Oleg Pykhalov <[email-masked]>
>>> Date: Thu, 11 Jan 2018 01:14:41 +0300
>>> Subject: [PATCH] gnu: Add urho3d.
>>>
>>> * gnu/packages/game-development.scm (urho3d): New public variable.
>>
>> [...]
>>
>>> +           (lambda* (#:key inputs #:allow-other-keys)
>>> +             (substitute* (string-append "../build/Source/ThirdParty"
>>> +                                         "/SDL/include/generated/SDL_config.h")
>>
>> IIUC there’s a bundled copy of SDL, right?  Can we instead build against
>> our SDL?
>
> Yes, it's a bundled copy.  We probably can, but how?  The build system
> probably configured look for 'Source/ThirdParty/SDL'.  So should we make
> a symbolic link like 'Source/ThirdParty/SDL' -> '/gnu/store/…-SDL'?

Rather, we should adjust CMakeLists.txt (if needed) so that it links
against our copy of SDL, like Fis Trivial did with ‘rct’ today.

>> Ideally, to be safe from bundling, we should “rm -rf ThirdParty” in a
>> snippet.  Is that possible?
>
> Unfortunately no.  The contents of the 'Source/ThirdParty' has much more
> than just SDL.  It's too much work for now, but a good TODO.
>
> Source/ThirdParty/SDL
>
>     AngelScript Assimp boost Box2D Bullet Civetweb Detour DetourCrowd
>     DetourTileCache FreeType GLEW ik JO kNet LibCpuId LICENSES Lua
>     LuaJIT LZ4 MojoShader Mustache nanodbc PugiXml rapidjson Recast SDL
>     SQLite StanHull STB toluapp WebP

Ouch, that’s a lot of stuff!  We should at least remove boost, FreeType,
GLEW, Lua, LuaJIT, LZ4, SDL, and SQLite, for which we have packages.

> Actually I wonder will those libraries and the engine overall play nice
> with OUR SDL library?  Should we provide a Guix version and bundled
> libraries version?

We’ll have to try; hopefully they’re shipping an unmodified SDL.

> From 5a906d8a8a9ff50ed46b5ffc33714b11517e23ca Mon Sep 17 00:00:00 2001
> From: Oleg Pykhalov <[email-masked]>
> Date: Thu, 11 Jan 2018 01:14:41 +0300
> Subject: [PATCH] gnu: Add urho3d.
>
> * gnu/packages/game-development.scm (urho3d): New public variable.

Could you please try unbundling the things mentioned above, and add a
FIXME for those we’re not unbundling yet?  We should try and see how
difficult it is; for ‘rct’ it was OK.

Thank you!

Ludo’.